#!/bin/zsh

# Copyright 2014, 2015 Paul Hänsch
#
# This file is part of shcgi.
# 
# shcgi is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# shcgi is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public License
# along with shcgi.  If not, see <http://www.gnu.org/licenses/>. 

export LC_ALL=C LANG=C

# this program is supposed to be symlinked into a http root directory
# we will use the http root as object storage (data directory) and call sub
# programs from the directory in which the real executable resides
# therefore we need to identify the code and data directories _EXEC and _DATA
call="$0"
real="$(readlink -f $call)"
_DATA="$(dirname "$call")"  #storage directory
_EXEC="${real%/shcgi/index.cgi}"  #execution directory

. "$_EXEC/shcgi/misc.sh"
# put debug options in the local.opts file
. "$_EXEC/shcgi/debug.sh"
[ -r "$_DATA/local.opts" ] && . "$_DATA/local.opts"

. "$_EXEC/shcgi/cgi.sh"
cgi_get

[ -x "$_EXEC/globals.sh" ] && . "$_EXEC/globals.sh"

if [ -n "${_GET[action]}" ]; then
  . "$_EXEC/shcgi/action.sh"
else
  . "$_EXEC/shcgi/page.sh"
fi
